--{{{  LIB krnlhdr
--{{{  common array sizes
VAL max.record.size IS 512 :
VAL max.string.size IS 256 :
VAL abs.id.size IS 63:
--}}} 
--{{{  TDS file representation
--{{{  item classes + terminate (not seen by user)
VAL data.item      IS 0 :
VAL fold.item      IS 1 :
VAL file.item      IS 2 :
VAL fold.open      IS 3 :
VAL file.open      IS 4 :
VAL end.open       IS 5 :     -- not passed across fld manager interface
VAL volume.item    IS 7 :
VAL volume.open    IS 8 :
VAL terminate.item IS 9 :
--}}} 
--{{{  file elements and record representation
--{{{  tag values
VAL tag.record IS 0 :
VAL tag.number IS 1 :
VAL tag.function IS 2 :
VAL tag.prefix IS 3 :
--}}} 
--{{{  field definitions
VAL tagfield.size IS 2 :
VAL datafield.size IS 6 :
VAL datamask IS #3F :
VAL tagmask IS #C0 :

VAL record.byte IS tag.record << datafield.size :
VAL number.byte IS tag.number << datafield.size :
VAL function.byte IS tag.function << datafield.size :
VAL prefix.byte IS tag.prefix << datafield.size :
--}}} 
--{{{  function values
VAL fn.startlist IS 0 :
VAL fn.endlist IS 1 :
VAL fn.startfold IS 2 :
VAL fn.endfold IS 3 :
VAL fn.startfile IS 4 :
VAL fn.endfile IS 5 :
VAL fn.terminate IS 6 :
--}}} 
--{{{  function.bytes
VAL startlist.byte  IS function.byte \/ fn.startlist :
VAL endlist.byte    IS function.byte \/ fn.endlist :
VAL startfold.byte  IS function.byte \/ fn.startfold :
VAL endfold.byte    IS function.byte \/ fn.endfold :
VAL startfiled.byte IS function.byte \/ fn.startfile :
VAL endfiled.byte   IS function.byte \/ fn.endfile :
VAL terminate.byte  IS function.byte \/ fn.terminate :
--}}} 
--}}} 
--}}} 
--{{{  kernel filer protocol (server interface)
--{{{  Filer command tags
VAL tkf.min.command           IS 1 :
VAL tkf.lock.read             IS 1 :
VAL tkf.lock.write            IS 2 :
VAL tkf.release               IS 3 :
VAL tkf.open.read             IS 4 :
VAL tkf.open.write            IS 5 :
VAL tkf.close                 IS 6 :
VAL tkf.read                  IS 7 :
VAL tkf.write                 IS 8 :
VAL tkf.suspend               IS 9 :
VAL tkf.resume                IS 10 :
VAL tkf.named.file.store      IS 11 :
VAL tkf.ascii.to.id           IS 12 :
VAL tkf.id.to.ascii           IS 13 :
VAL tkf.derive.id             IS 14 :
VAL tkf.create.file           IS 15 :
VAL tkf.get.version           IS 16 :
VAL tkf.move.file.id          IS 17 :
VAL tkf.can.move              IS 18 :
VAL tkf.can.delete            IS 19 :
VAL tkf.can.copy              IS 20 :
VAL tkf.move.file             IS 21 :
VAL tkf.delete.file           IS 22 :
VAL tkf.copy.file             IS 23 :
VAL tkf.exists.file           IS 24 :
VAL tkf.number.of.chrc        IS 25 :
VAL tkf.chrc.can.change       IS 26 :
VAL tkf.chrc.name             IS 27 :
VAL tkf.open.read.chrc        IS 28 :
VAL tkf.open.write.chrc       IS 29 :
VAL tkf.read.chrc             IS 30 :
VAL tkf.write.chrc            IS 31 :
VAL tkf.close.chrc            IS 32 :
VAL tkf.get.error             IS 33 :
VAL tkf.stop                  IS 34 :
VAL tkf.format                IS 35 :
VAL tkf.zero                  IS 36 :
VAL tkf.seek                  IS 37 :
VAL tkf.free.space            IS 38 :
VAL tkf.open.read.text        IS 39 :
VAL tkf.open.write.text       IS 40 :
VAL tkf.reset.channel         IS 41 :
VAL tkf.file.length           IS 42 :
VAL tkf.truncate              IS 43 :
VAL tkf.rename                IS 44 :
VAL tkf.SP.transactions       IS 45 : -- used inside TDS3

VAL tkf.open.block.read       IS 50 :
VAL tkf.open.block.write      IS 51 :
VAL tkf.open.block.update     IS 52 :
VAL tkf.open.var.rec.read     IS 53 :
VAL tkf.open.var.rec.write    IS 54 :
VAL tkf.open.var.rec.update   IS 55 :
VAL tkf.open.fixed.rec.read   IS 56 :
VAL tkf.open.fixed.rec.write  IS 57 :
VAL tkf.open.fixed.rec.update IS 58 :
VAL tkf.toolkit.file.id       IS 59 :
VAL tkf.delete.file.id        IS 60 :
VAL tkf.pick.file.id          IS 61 :

VAL tkf.max.command           IS 61 :
--}}} 
--{{{  Filer response tags
VAL fkf.min.command           IS 1 :
VAL fkf.lock.read             IS 1 :
VAL fkf.lock.write            IS 2 :
VAL fkf.release               IS 3 :
VAL fkf.open.read             IS 4 :
VAL fkf.open.write            IS 5 :
VAL fkf.close                 IS 6 :
VAL fkf.read                  IS 7 :
VAL fkf.write                 IS 8 :
VAL fkf.suspend               IS 9 :
VAL fkf.resume                IS 10 :
VAL fkf.named.file.store      IS 11 :
VAL fkf.ascii.to.id           IS 12 :
VAL fkf.id.to.ascii           IS 13 :
VAL fkf.derive.id             IS 14 :
VAL fkf.create.file           IS 15 :
VAL fkf.get.version           IS 16 :
VAL fkf.move.file.id          IS 17 :
VAL fkf.can.move              IS 18 :
VAL fkf.can.delete            IS 19 :
VAL fkf.can.copy              IS 20 :
VAL fkf.move.file             IS 21 :
VAL fkf.delete.file           IS 22 :
VAL fkf.copy.file             IS 23 :
VAL fkf.exists.file           IS 24 :
VAL fkf.number.of.chrc        IS 25 :
VAL fkf.chrc.can.change       IS 26 :
VAL fkf.chrc.name             IS 27 :
VAL fkf.open.read.chrc        IS 28 :
VAL fkf.open.write.chrc       IS 29 :
VAL fkf.read.chrc             IS 30 :
VAL fkf.write.chrc            IS 31 :
VAL fkf.close.chrc            IS 32 :
VAL fkf.get.error             IS 33 :
VAL fkf.stop                  IS 34 :
VAL fkf.format                IS 35 :
VAL fkf.zero                  IS 36 :
VAL fkf.seek                  IS 37 :
VAL fkf.free.space            IS 38 :
VAL fkf.open.read.text        IS 39 :
VAL fkf.open.write.text       IS 40 :
VAL fkf.reset.channel         IS 41 :
VAL fkf.file.length           IS 42 :
VAL fkf.truncate              IS 43 :
VAL fkf.rename                IS 44 :
VAL fkf.SP.transactions       IS 45 : -- used inside TDS3

VAL fkf.open.block.read       IS 50 :
VAL fkf.open.block.write      IS 51 :
VAL fkf.open.block.update     IS 52 :
VAL fkf.open.var.rec.read     IS 53 :
VAL fkf.open.var.rec.write    IS 54 :
VAL fkf.open.var.rec.update   IS 55 :
VAL fkf.open.fixed.rec.read   IS 56 :
VAL fkf.open.fixed.rec.write  IS 57 :
VAL fkf.open.fixed.rec.update IS 58 :
VAL fkf.toolkit.file.id       IS 59 :
VAL fkf.delete.file.id        IS 60 :
VAL fkf.pick.file.id          IS 61 :

VAL fkf.max.command           IS 61 :
--}}} 
--{{{  f. numbers
VAL f.ok IS 0:
VAL f.eof IS 1:
VAL t.too.many.locks IS -303:
VAL t.too.many.releases IS -305:
VAL t.too.many.suspends IS -306:
VAL f.illegal.chrc      IS -308:
VAL f.cannot.copy       IS -311:
VAL f.illegal.extension IS -313:
VAL f.illegal.attribute IS -314:
VAL f.invalid.operation IS -1105:

VAL f.chrc.date IS 1:
VAL f.chrc.size IS 2:
VAL f.chrc.prot IS 3:
VAL f.num.chrcs IS 3:
--}}} 
--{{{  kernel interface commands etc
--{{{  offsets for numbers saved by the server
VAL code.start.item IS 0 :

VAL code.start.addr.item IS 1 :
VAL code.length.item IS 2 :
VAL free.start.addr.item IS 3 :
VAL free.length.item IS 4 :
VAL work.start.addr.item IS 5 :
VAL work.length.item IS 6 :
VAL vec.start.addr.item IS 7 :
VAL vec.length.item IS 8 :
VAL num.details IS 8:

VAL tds.code.start.item IS 9 :
VAL num.saved.items IS 10:
--}}} 

VAL k.get.result       IS 1 :
VAL k.get.iptr         IS 2 :
VAL k.get.val          IS 3 :
VAL k.get.last.error   IS 4 :
VAL k.clear.result     IS 5 :
VAL k.clear.last.error IS 6 :
VAL k.terminate        IS 7 :
VAL k.store.item       IS 8 :
VAL k.retrieve.item    IS 9 :
VAL k.get.char         IS 10 :
VAL k.retrieve.mem     IS 11 :
VAL k.suspend.tds      IS 12 :
VAL k.get.iptr.address IS 13 :
VAL k.get.instruction  IS 14 : -- previously 9 :
VAL k.get.abort.state  IS 15 :
VAL k.put.exe.details  IS 16 :

VAL k.put.code.start   IS 20 :
VAL k.get.code.start   IS 21 :

VAL k.finish.ok        IS 0 :
VAL k.halted           IS -16 :
--}}} 
--}}} 
--}}} 
